/*!Amalia.js V1.2.3, © INA 2015 */
/**
 * Copyright (c) 2015 Institut National de l'Audiovisuel, INA
 * This file is part of amalia.js

 * amalia.js is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * Redistributions of source code, javascript and css minified versions
 * must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Neither the name of the copyright holder nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.

 * You should have received a copy of the GNU General Public License
 * along with amalia.js. If not, see <http://www.gnu.org/licenses/>

 *
 * amalia.js is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

$.Class("fr.ina.amalia.player.helpers.BrowserFeatureDetection",{isMobilePlatform:function(){return navigator.userAgent.match(/(iPod|iPhone|iPad)/)||navigator.userAgent.toLowerCase().indexOf("android")>-1}},{settings:{},logger:null,init:function(a){this.settings=$.extend({debug:!1},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug}))},isSupportsVideos:function(){return document.createElement("video").canPlayType?(null!==this.logger&&this.logger.info("Support html5"),!0):(null!==this.logger&&this.logger.info("Can't support html5"),!1)},isSupportsMp4:function(){if(this.isSupportsVideos()){var a=document.createElement("video");return a.canPlayType("video/mp4")?(null!==this.logger&&this.logger.info("Support mp4"),!0):(null!==this.logger&&this.logger.info("Can't support mp4"),!1)}return!1}}),$.Class("fr.ina.amalia.player.helpers.HTML5Helper",{isFullScreen:function(){var a=$(document).context;return a.fullscreen||a.mozFullScreen||a.webkitIsFullScreen},toggleFullScreen:function(a,b){var c=$(document).context,d=c.fullscreen||c.mozFullScreen||c.webkitIsFullScreen?!0:!1;if(d===!1||b===!0){var e=a.requestFullScreen||a.webkitRequestFullScreen||a.mozRequestFullScreen||a.msRequestFullscreen||a.webkitEnterFullscreen;if("undefined"!=typeof e&&e)return e.call(a),!0}else{var f=document.cancelFullScreen||document.mozCancelFullScreen||document.webkitCancelFullScreen;if("undefined"!=typeof f&&f)return f.call(document),!1}}},{}),$.Class("fr.ina.amalia.player.helpers.UtilitiesHelper",{formatTime:function(a,b,c){var d=d||"f",e=b||25,f=Math.floor(Math.floor(1e5*(a-Math.floor(a)))*e/1e5),g=Math.floor(a/60),h=Math.floor(g/60),i=a%60;switch(a=Math.floor(a%60),g=Math.floor(g%60),g=g>=10?g:"0"+g,h=h>=10?h:"0"+h,a=a>=10?a:"0"+a,f=f>=10?f:"0"+f,c){case"h":d=h;break;case"m":d=h+":"+g;break;case"s":d=h+":"+g+":"+a;break;case"mms":d=h+":"+g+":"+a+"."+i.toFixed(4).split(".")[1];break;case"ms":d=h+":"+g+":"+a+"."+i.toFixed(2).split(".")[1];break;case"f":d=h+":"+g+":"+a+":"+f;break;case"f_imp":d=h+":"+g+":"+a+"."+f;break;default:d=h+":"+g+":"+a+":"+i.toFixed(2).split(".")[1]}return d},getTimeRange:function(a,b,c){var d=[],e=c||25,f="undefined"==typeof b?"1":b;a=Math.floor(a);for(var g=0;a>=g;g+=f)if("f"===b){g=Math.floor(g);for(var h=0;e>h;h++)g+=1e3/e/1e3,d.push(fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(g,c))}else d.push(fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(g,c));return d},getRangesWithStartAndEndTime:function(a,b,c){for(var d=[],e="undefined"==typeof c?"1":c,f=a;b>=f;f+=e)d.push(f);return d},convertHourToSeconde:function(a){var b=null,c=/\d{2}:\d{2}:\d{2}/,d=c.exec(a);if(null!==d){d=a.split(":");var e=Math.floor(d[0]),f=Math.floor(d[1]),g=parseFloat(d[2]);b=60*e*60+60*f+g}return b},uint6ToB64:function(a){return 26>a?a+65:52>a?a+71:62>a?a-4:62===a?43:63===a?47:65},b64ToUint6:function(a){return a>64&&91>a?a-65:a>96&&123>a?a-71:a>47&&58>a?a+4:43===a?62:47===a?63:0},base64DecToArr:function(a,b){for(var c,d,e=a.replace(/[^A-Za-z0-9\+\/]/g,""),f=e.length,g=b?Math.ceil((3*f+1>>2)/b)*b:3*f+1>>2,h=new Uint8Array(g),i=0,j=0,k=0;f>k;k++)if(d=3&k,i|=fr.ina.amalia.player.helpers.UtilitiesHelper.b64ToUint6(e.charCodeAt(k))<<18-6*d,3===d||f-k===1){for(c=0;3>c&&g>j;c++,j++)h[j]=i>>>(16>>>c&24)&255;i=0}return h}},{}),$.Class("fr.ina.amalia.player.PlayerErrorCode",{ACCESS_DENIED:1001,MEDIA_FILE_NOT_FOUND:2001,CUSTOM_ERROR:3001,EXCEPTION:4001,HTTP_ERROR:5001,ABORT:6001,TIMEOUT:7008,ERROR:8008,ERROR_HTML5_SUPPORT:8e3,ERROR_LOAD_PLUGIN:9001,getMessage:function(a){var b=fr.ina.amalia.player.PlayerErrorCode,c=fr.ina.amalia.player.PlayerErrorMessage;switch(a){case b.ACCESS_DENIED:return c.ACCESS_DENIED;case b.MEDIA_FILE_NOT_FOUND:return c.MEDIA_FILE_NOT_FOUND;case b.EXCEPTION:return c.EXCEPTION;case b.HTTP_ERROR:return c.HTTP_ERROR;case b.ABORT:return c.ABORT;case b.TIMEOUT:return c.TIMEOUT;case b.ERROR_LOAD_PLUGIN:return c.ERROR_LOAD_PLUGIN;case b.CUSTOM_ERROR:return c.CUSTOM_ERROR;case b.ERROR:return c.ERROR;case b.ERROR_HTML5_SUPPORT:return c.ERROR_HTML5_SUPPORT;default:return c.DEFAULT}}},{}),$.Class("fr.ina.amalia.player.PlayerErrorMessage",{ACCESS_DENIED:"Accès refusé.",MEDIA_FILE_NOT_FOUND:"Erreur lors du chargement du média.",EXCEPTION:"An exception occurred.",HTTP_ERROR:"Http response at 400 or 500 level.",ABORT:"Votre requête a été interrompue.",TIMEOUT:"Demande dépassé.",ERROR_LOAD_PLUGIN:"Erreur inattendue lors de l'initialisation du plug-in.",CUSTOM_ERROR:"Une erreur s'est produite sur votre lecteur.",ERROR:"Une erreur s'est produite sur votre lecteur.",DEFAULT:"Une erreur s'est produite sur votre lecteur.",ERROR_HTML5_SUPPORT:"Une erreur s'est produite sur votre lecteur: Votre navigateur ne gère pas les balises HTML5."},{}),$.Class("fr.ina.amalia.player.PlayerEventType",{STARTED:"fr.ina.amalia.player.PlayerEventType.STARTED",PLAYING:"fr.ina.amalia.player.PlayerEventType.PLAYING",PAUSED:"fr.ina.amalia.player.PlayerEventType.PAUSED",ENDEN:"fr.ina.amalia.player.PlayerEventType.ENDEN",MUTE:"fr.ina.amalia.player.PlayerEventType.MUTE",UN_MUTE:"fr.ina.amalia.player.PlayerEventType.UN_MUTE",VOLUME_CHANGE:"fr.ina.amalia.player.PlayerEventType.VOLUME_CHANGE",TIME_CHANGE:"fr.ina.amalia.player.PlayerEventType.TIME_CHANGE",FULLSCREEN_CHANGE:"fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE",SEEK:"fr.ina.amalia.player.PlayerEventType.SEEK",ERROR:"fr.ina.amalia.player.PlayerEventType.ERROR",PLUGIN_READY:"fr.ina.amalia.player.PlayerEventType.PLUGIN_READY",PLUGIN_ERROR:"fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR",DATA_CHANGE:"fr.ina.amalia.player.PlayerEventType.DATA_CHANGE",IMAGE_CAPTURE:"fr.ina.amalia.player.PlayerEventType.IMAGE_CAPTURE",ZOOM_RANGE_CHANGE:"fr.ina.amalia.player.PlayerEventType.ZOOM_RANGE_CHANGE"},{}),$.Class("fr.ina.amalia.player.PlayerMessage",{PLAYER_OPENSOURCE_LINK:"Disponible en open source.",PLUGIN_OVERLAY_CONTEXT_MENU_ENABLED_DISABLED_PLUGIN:"Activer/désactiver le plugin overlay.",PLUGIN_TIMELINE_LABEL_ELEMENTS:"éléments.",PLUGIN_TIMELINE_LABEL_ZOOM_IN:"Zoom avant",PLUGIN_TIMELINE_LABEL_ZOOM_OUT:"Zoom arrière",PLUGIN_TIMELINE_LABEL_CHANGE_DISPLAY:"Changer la hauteur des lignes.",PLUGIN_TIMELINE_LABEL_SLIDE_LEFT:"Faire défiler vers la gauche",PLUGIN_TIMELINE_LABEL_SLIDE_RIGHT:"Faire défiler vers la droit",PLUGIN_TIMELINE_LABEL_SCROLL_UP:"Faire défiler vers le haut",PLUGIN_TIMELINE_LABEL_SCROLL_DOWN:"Faire défiler vers le bas",PLUGIN_TIMELINE_LABEL_SHOW_HIDE_TOOTIP:"Activer/désactiver les infobulles",PLUGIN_TIMELINE_LABEL_EXPAND:"Maximiser",PLUGIN_TIMELINE_LABEL_SORT:"Trier",PLUGIN_TIMELINE_LABEL_NAV_POINT_PREV:"Aller au marqueur précédent",PLUGIN_TIMELINE_LABEL_NAV_POINT_NEXT:"Aller au marqueur suivant",PLUGIN_TIMELINE_LABEL_TIMEAXE:"Axe temporel",PLUGIN_TIMELINE_LABEL_FOCUS:"Zoom",PLUGIN_TIMELINE_LABEL_CLOSE:"Fermer"},{}),$.Class("fr.ina.amalia.player.LoaderBase",{},{settings:{},logger:null,requestType:"GET",dataType:"json",sendData:{},timeout:12e4,data:null,handlerData:{},completeHandler:null,init:function(a,b,c){this.settings=$.extend({debug:!1},a||{}),this.handlerData=$.extend({debug:!1},c||{}),this.completeHandler=b,"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")},setRequestType:function(a){this.requestType=a},setDataType:function(a){this.dataType=a},setTimeout:function(a){this.timeout=a},setSendData:function(a){this.sendData=$.extend(this.sendData,a||{})},getSendData:function(){return this.sendData},getData:function(){return this.data},processFilterData:function(a){if(null!==a&&"undefined"!=typeof a){if(a.hasOwnProperty("status")===!0&&a.hasOwnProperty("data")===!0&&0===a.status&&null!==a)return a.data;if(a.hasOwnProperty("id")===!0)return a;null!==this.logger&&(this.logger.warn(this.Class.fullName,"Error while filtering Data."),this.logger.warn(a))}return null},load:function(a){var b=this;$.ajax({type:this.requestType,url:a,timeout:this.timeout,data:this.sendData,dataType:this.dataType,success:function(a,c){b.onSuccess(a,c)},error:function(a,c){b.onError(c)}})},onSuccess:function(a,b){null!==this.logger&&this.logger.trace(this.Class.fullName,"onSuccess status: "+b),this.data=this.processFilterData(a),"function"==typeof this.completeHandler&&this.completeHandler(this.handlerData,b)},onError:function(a){null!==this.logger&&this.logger.trace(this.Class.fullName,"onError status :"+a),this.data=null,"function"==typeof this.completeHandler&&this.completeHandler(this.handlerData,a)}}),$.Class("fr.ina.amalia.player.MediaFactory",{},{settings:{},logger:null,mediaContainer:null,player:null,errorContainer:null,init:function(a,b){this.mediaContainer=$(a),this.settings=$.extend({src:null,poster:"",autoplay:!1,plugins:{},callbacks:{},debug:!1},b||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.initialize()},initialize:function(){try{this.loadPlayer(),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")}catch(a){this.createErrorContainer(),this.setErrorCode(8e3),null!==this.logger&&this.logger.error(a.stack)}},createErrorContainer:function(){this.errorContainer=$("<div>",{"class":"inaplayer-error"}),this.errorContainer.hide(),this.mediaContainer.append(this.errorContainer)},setErrorCode:function(a){if("undefined"!=typeof this.errorContainer){var b=$("<p>",{text:fr.ina.amalia.player.PlayerErrorCode.getMessage(a)});this.errorContainer.html(b),this.errorContainer.show()}},loadPlayer:function(){if(null!==this.logger&&this.logger.trace(this.Class.fullName,"Load html 5 media player"),null===this.src)throw new Error("Can't find media src");var a=new fr.ina.amalia.player.helpers.BrowserFeatureDetection;if(!a.isSupportsVideos())throw null!==this.logger&&this.logger.error("Your browser does not support the video tag."),new Error("Your browser does not support the video tag.");this.loadHtml5MediaPlayer()},loadHtml5MediaPlayer:function(){null!==this.logger&&this.logger.info("Load html 5 media player"),this.player=new fr.ina.amalia.player.PlayerHtml5(this.settings,this.mediaContainer)},getPlayer:function(){return this.player}}),$.Class("fr.ina.amalia.player.plugins.PluginBase",{classCss:"plugin-default",style:""},{pluginContainer:null,mediaPlayer:null,logger:null,loaderContainer:null,settings:{},eventTag:"",init:function(a,b,c){if(this.mediaPlayer=b,this.pluginContainer=$(c),this.namespace=this.Class.fullName,this.settings=$.extend({debug:!1,internalPlugin:!1},a||{}),this.eventTag=this.Class.fullName+"_"+this.pluginContainer.attr("id"),this.settings.internalPlugin===!1&&(this.pluginContainer.addClass(this.Class.classCss),this.createLoader(),this.loaderContainer.show()),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),null===this.mediaPlayer)throw new Error("Can't initialize plugin name"+this.Class.fullName);try{if(this.settings.internalPlugin===!1){var d=this.mediaPlayer.getMediaPlayer();d.on(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY,{self:this},this.onPluginReady),d.on(fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR,{self:this},this.onPluginError)}else this.initialize()}catch(e){null!==this.logger&&this.logger.error(e.stack)}},initialize:function(){},initializeError:function(a){var b=fr.ina.amalia.player.PlayerErrorCode.getMessage(a),c=$("<div>",{"class":"inaplayer-error",style:"",text:b});this.pluginContainer.append(c)},createLoader:function(){this.loaderContainer=$("<div>",{"class":"loader fa fa-cog fa-spin",style:""}),this.loaderContainer.hide(),this.pluginContainer.append(this.loaderContainer)},onPluginReady:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPluginReady"),null!==a.data.self&&(a.data.self.initialize(),null!==a.data.self.loaderContainer&&a.data.self.loaderContainer.hide())},onPluginError:function(a,b){if(null!==a.data.self.logger&&a.data.self.logger.warn("PluginBase/onPluginError"),null!==a.data.self){var c="undefined"==typeof b.errorCode?"":b.errorCode;a.data.self.initializeError(c),null!==a.data.self.loaderContainer&&a.data.self.loaderContainer.hide()}}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.captions.CaptionsBase",{},{container:null,listOfData:[],definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},updateMetadata:function(a,b,c,d,e){var f=null,g=null;e=e||!1,g=this.mediaPlayer.getMetadataWithRange(a,c,d);for(var h=0;h<g.length;h++)f=g[h],f.hasOwnProperty("sublocalisations")===!0&&null!==f.sublocalisations?this._parseSubLocalisations(f.sublocalisations,b,e):null!==f?this._parseLocalisation(f,b,e):null!==this.logger&&this.logger.trace(this.Class.fullName,"Error to set data, index: "+h)},_parseLocalisation:function(a,b,c){var d=null;if(a.tclevel<=b){if(a.tclevel===b&&c===!1||a.tclevel<=b&&c===!0){var e=this._getText(a.data);""!==e&&(d={tcin:"number"==typeof a.tcin?a.tcin:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(a.tcin),tcout:"number"==typeof a.tcout?a.tcout:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(a.tcout),text:e,label:a.label,thumb:a.thumb,level:a.tclevel},this.listOfData.push(d))}a.hasOwnProperty("sublocalisations")===!0&&null!==a.sublocalisations&&a.sublocalisations.hasOwnProperty("localisation")===!0&&$.isArray(a.sublocalisations.localisation)&&this._parseSubLocalisations(a.sublocalisations,b,c)}},_parseSubLocalisations:function(a,b,c){var d=null;if(null!==a&&"undefined"!=typeof a&&a.hasOwnProperty("localisation")===!0&&$.isArray(a.localisation))for(var e=0;e<a.localisation.length;e++)d=a.localisation[e],this._parseLocalisation(d,b,c);return d},_getText:function(a){var b="";if(null!==a&&"undefined"!=typeof a&&a.hasOwnProperty("text")===!0&&null!==a.text&&$.isArray(a.text))for(var c=0;c<a.text.length;c++)null!==a.text[c]&&(b+=a.text[c].toString());return b},updatePos:function(a){null!==this.logger&&this.logger.trace(this.Class.fullName,"updatePos : "+a)},onTimeupdate:function(a,b){a.data.self.updatePos(parseFloat(b.currentTime))}}),$.Class("fr.ina.amalia.player.plugins.PluginManager",{},{settings:{},logger:null,pluginsSettings:{},plugins:null,mediaContainer:null,mediaPlayer:null,contextMenuPlugin:null,loadedCount:0,failCount:0,dataLoaded:0,init:function(a,b,c){this.mediaPlayer=b,this.mediaContainer=c,this.settings=$.extend({debug:!1},a||{}),this.pluginsSettings=$.extend({debug:this.settings.debug,dataServices:[],list:[]},a.plugins||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.plugins=[],this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize");var a={internalPlugin:!0};this.contextMenuPlugin=this.loadPlugin("fr.ina.amalia.player.plugins.ContextMenuPlugin",a,this.mediaPlayer,this.mediaContainer);var b=$.extend({internalPlugin:!0,framerate:this.settings.framerate,debug:this.settings.debug},this.settings.controlBar||{});this.loadPlugin(this.settings.controlBarClassName,b,this.mediaPlayer,this.mediaContainer),this.loadDynamicPlugins(this.pluginsSettings.list),this.mediaPlayer.mediaPlayer.one(fr.ina.amalia.player.PlayerEventType.STARTED,{self:this},this.onStarted),this.mediaPlayer.mediaPlayer.on(fr.ina.amalia.player.PlayerEventType.ERROR,{self:this},this.onError)},getContextMenuPlugin:function(){return this.contextMenuPlugin},onStarted:function(a){a.data.self.loadData(a.data.self.pluginsSettings.dataServices)},onError:function(a){a.data.self.mediaPlayer.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR,{errorCode:fr.ina.amalia.player.PlayerErrorCode.ERROR_LOAD_PLUGIN})},loadData:function(a){if($.isArray(a)){var b=0,c=null,d={debug:this.settings.debug};for(b=0;b<a.length;++b)c=new fr.ina.amalia.player.LoaderBase(d,this.dataLoadedHandler,{self:this}),c.load(a[b])}else null!==this.logger&&this.logger.warn("Error dataServices is not array.")},dataLoadedHandler:function(a,b){"success"===b&&null!==this.getData()?(a.self.mediaPlayer.addMetadata(this.getData()),a.self.dataLoaded++,a.self.dataLoaded===a.self.pluginsSettings.dataServices.length&&a.self.mediaPlayer.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY)):(null!==this.logger&&(this.logger.warn("Failed to load data. status: "+b),this.logger.warn(a)),a.self.mediaPlayer.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLUGIN_ERROR,{errorCode:fr.ina.amalia.player.PlayerErrorCode.ERROR_LOAD_PLUGIN}))},loadDynamicPlugins:function(a){null!==this.logger&&(this.logger.info(this.Class.fullName,"loadPlugins List : "),this.logger.info(a));for(var b in a){var c=a[b];if(c=$.extend({debug:this.pluginsSettings.debug,className:null,container:null,data:this.data,parameters:{}},c||{}),"object"==typeof c&&null!==c.className){var d=null===c.container?this.mediaContainer:$(c.container);c.internalPlugin=null===c.container,this.loadPlugin(c.className,c,this.mediaPlayer,d)}else null!==this.logger&&this.logger.warn(this.Class.fullName,"Error to load plugin className:"+c.className)}},loadPlugin:function(className,settings,mediaPlayer,pluginContainer){null!==this.logger&&this.logger.info(this.Class.fullName,"loadPlugin className:"+className);try{var obj=eval("new "+className+"(settings,mediaPlayer,pluginContainer)");return this.plugins.push(obj),this.loadedCount++,null!==this.logger&&this.logger.info(className+"Plugin loaded :  "+className),obj}catch(error){return this.failCount++,null!==this.logger&&(this.logger.warn("Error to load plugin : "+className),this.logger.warn(error.stack)),!1}}}),$.Class("fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase",{},{settings:{},logger:null,element:null,component:null,mediaPlayer:null,init:function(a,b,c){this.parameter=$.extend({debug:!0},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.parameter.debug})),this.container=c,this.mediaPlayer=b,this.initialize()},initialize:function(){},show:function(){this.component.show()},hide:function(){this.component.hide()}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.BaseButton",{classCss:"player-base-button",style:""},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":"button-container"}),b=$("<span>",{"class":this.parameter.style});a.append(b),this.component.on("click",{self:this,component:this.component},this.onClick),this.component.append(a),this.container.append(this.component)},onClick:function(event){if("undefined"!=typeof event.data.self.parameter.callback)try{eval(event.data.self.parameter.callback+"(event.data.self.mediaPlayer, event.data.self.parameter)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.TimeLabel",{classCss:"player-timelabel time-display off",style:"",eventTypes:{}},{currentTime:null,timeSeparator:null,duration:null,initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style}),this.currentTime=$("<span>",{"class":"time-current"}),this.timeSeparator=$("<span>",{"class":"time-separator"}),this.duration=$("<span>",{"class":"time-duration"}),this.component.append(this.currentTime),this.component.append(this.timeSeparator),this.component.append(this.duration),this.container.append(this.component),this.definePlayerEvents()},setCurrentTime:function(a){null!==this.currentTime&&this.currentTime.html(a)},setDuration:function(a){null!==this.duration&&(this.duration.html(a),this.component.removeClass("off").addClass("on"))},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimechange)},onTimechange:function(a,b){var c=fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b.currentTime,a.data.self.parameter.framerate,a.data.self.parameter.timeFormat),d=fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b.duration,a.data.self.parameter.framerate,a.data.self.parameter.timeFormat);a.data.self.setCurrentTime(c),a.data.self.setDuration(d)}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.PlayButton",{classCss:"player-play-button",style:""},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":"button-container"}),b=$("<i>",{"class":"fa fa-play fa-2x"});a.append(b),this.component.append(a),this.component.on("click",{self:this,component:this.component},this.onClick),this.container.append(this.component),this.definePlayerEvents()},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlaying),this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PAUSED,{self:this},this.onPaused)},onClick:function(a){a.data.self.mediaPlayer.play()},onPlaying:function(a){a.data.self.component.addClass("off").removeClass("on")},onPaused:function(a){a.data.self.component.addClass("on").removeClass("off")}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.PauseButton",{classCss:"player-pause-button",style:""},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":"button-container round"}),b=$("<i>",{"class":"fa fa-pause fa-2x"});a.append(b),this.component.append(a),this.component.on("click",{self:this,component:this.component},this.onClick),this.container.append(this.component),this.definePlayerEvents(),this.component.addClass("off").removeClass("on")},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlaying),this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.PAUSED,{self:this},this.onPaused)},onClick:function(a){a.data.self.mediaPlayer.pause()},onPlaying:function(a){a.data.self.component.addClass("on").removeClass("off")},onPaused:function(a){a.data.self.component.addClass("off").removeClass("on")}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.FullscreenButton",{classCss:"player-fullscreen-button",classCssFullscreenOn:"fa fa-expand fa-2x",classCssFullscreenOff:"fa fa-compress fa-2x",style:"",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.widgets.FullscreenButton.event.click"}},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a=$("<span>",{"class":this.Class.classCssFullscreenOn});this.component.append(a),this.component.on("click",{self:this,component:this.component},this.onClick),this.container.append(this.component),this.setFullscreenMode(!1),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.definePlayerEvents()},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{self:this},this.onFullscreenModeChange)},setFullscreenMode:function(a){a===!0?this.component.find("span").removeClass(this.Class.classCssFullscreenOn).addClass(this.Class.classCssFullscreenOff):this.component.find("span").removeClass(this.Class.classCssFullscreenOff).addClass(this.Class.classCssFullscreenOn)},onClick:function(a){a.data.self.mediaPlayer.toggleFullScreen()},onFullscreenModeChange:function(a,b){a.data.self.setFullscreenMode(b.inFullScreen)}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.VolumeControlBar",{classCss:"player-volume-control",classCssVolumeOn:"fa-volume-up",classCssVolumeOff:"fa-volume-off",style:"",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.widgets.VolumeControlBar.event.click",CHANGE:"fr.ina.amalia.player.plugins.widgets.VolumeControlBar.event.change",HOVER:"fr.ina.amalia.player.plugins.widgets.VolumeControlBar.event.hover"}},{sliderStart:0,sliderEnd:100,defaultValue:100,volumeControlComponent:null,initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style});var a='<input class="volume-control" data-width="70" data-height="70" data-displayInput="false" data-displayPrevious="true" data-skin="tron" data-thickness=".2" data-fgColor="#13e7f0"value="'+this.defaultValue+'" >';this.component.append(a);var b=$("<div>",{"class":"volume-control-btn"}),c=$("<span>",{"class":"fa fa-2x"});b.append(c);var d=this;this.component.find("input.volume-control").knob({change:function(a){d.onSlide(a)}}),b.on("click",{self:this},this.onClickVolume),this.component.find("div").append(b),this.container.append(this.component),this.definePlayerEvents(),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.VOLUME_CHANGE,{self:this},this.onPlayerVolumeChange)},onClick:function(a){a.data.component.trigger(a.data.self.Class.eventTypes.CLICK),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClick/triggerevent:"+a.data.self.Class.eventTypes.CLICK)},setValue:function(a){this.component.find("input.volume-control").val(a).trigger("change"),0===a?(this.component.find(".volume-control-btn span:first").removeClass(this.Class.classCssVolumeOn),this.component.find(".volume-control-btn span:first").addClass(this.Class.classCssVolumeOff)):(this.component.find(".volume-control-btn span:first").removeClass(this.Class.classCssVolumeOff),this.component.find(".volume-control-btn span:first").addClass(this.Class.classCssVolumeOn))},onSlide:function(a){this.component.trigger(this.Class.eventTypes.CHANGE,{value:a}),this.mediaPlayer.setVolume(a),null!==this.logger&&this.logger.trace(this.Class.fullName,"onSlide/triggerevent:"+this.Class.eventTypes.CHANGE+" Value "+a)},onClickVolume:function(a){var b=$(a.currentTarget).find("span:first").hasClass(a.data.self.Class.classCssVolumeOn)===!0?0:100;a.data.self.mediaPlayer.setVolume(b),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onClickVolume:"+a.data.self.Class.eventTypes.CHANGE+" Value "+b)},onPlayerVolumeChange:function(a,b){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlayerVolumeChange"+parseInt(b.volume)),a.data.self.setValue(parseInt(b.volume))}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.ProgressBar",{classCss:"player-progress-bar",style:""},{sliderStart:0,sliderEnd:1e3,sliding:!1,defaultValue:0,lastSlideEvent:0,initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style}),this.component.slider({range:"min",min:this.sliderStart,max:this.sliderEnd,value:this.defaultValue,height:20,framepreview:!0,framepreviewTimeBound:500}),this.component.prepend($("<div>",{"class":"buffer-bar"})),this.component.on("slidestart",{self:this,component:this.component},this.onSlideStart),this.component.on("slidestop",{self:this,component:this.component},this.onSlideStop),this.parameter.framepreview===!0&&this.component.on("slide",{self:this,component:this.component},this.onSlide),this.container.append(this.component),this.definePlayerEvents()},setValue:function(a){this.sliding===!1&&this.component.slider("value",10*a)},setTitle:function(a){this.component.attr("title",a)},updateBuffer:function(a,b){this.component.find(".buffer-bar").css({left:a+"%",width:b+"%"})},definePlayerEvents:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimechange)},onTimechange:function(a,b){var c=fr.ina.amalia.player.helpers.UtilitiesHelper.formatTime(b.currentTime,a.data.self.settings.framerate,a.data.self.settings.timeFormat);a.data.self.setValue(b.percentage),a.data.self.setTitle(c);var d=a.data.self.mediaPlayer.getMediaPlayer().get(0).buffered.end(0),e=100*d/b.duration;a.data.self.updateBuffer(0,e)},onSlideStart:function(a,b){a.data.self.sliding=!0,a.data.self.mediaPlayer.pause(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onSlideStart Value : "+b.value)},onSlideStop:function(a,b){a.data.self.sliding=!1;var c=a.data.self.mediaPlayer.getDuration(),d=b.value/10,e=(c-a.data.self.mediaPlayer.getTcOffset())*d/100;a.data.self.mediaPlayer.setCurrentTime(e+a.data.self.mediaPlayer.getTcOffset()),a.data.self.mediaPlayer.play(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onSlideStop value : "+b.value)},onSlide:function(a,b){var c=new Date,d=c-a.data.self.lastSlideEvent;if(d>a.data.self.parameter.framepreviewTimeBound){a.data.self.lastSlideEvent=new Date;var e=a.data.self.mediaPlayer.getDuration(),f=b.value/10,g=(e-a.data.self.mediaPlayer.getTcOffset())*f/100;a.data.self.mediaPlayer.setCurrentTime(g+a.data.self.mediaPlayer.getTcOffset()),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onSlide value : "+b.value)}}}),fr.ina.amalia.player.plugins.controlBar.widgets.WidgetBase.extend("fr.ina.amalia.player.plugins.controlBar.widgets.Label",{classCss:"iplayer-Label label label-default",style:"",eventTypes:{}},{initialize:function(){this.component=$("<div>",{"class":this.Class.classCss,style:this.Class.style,text:this.parameter.defaultValue}),this.container.append(this.component),null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize")},setValue:function(a){this.component.html(a)}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.CustomControlBarPlugin",{classCss:"plugin-custom-controlbar"},{container:null,leftContainer:null,midContainer:null,rightContainer:null,widgets:null,height:130,progressBar:null,autoHide:!0,displayState:!0,hideDuration:500,autoHideStarted:!1,initialize:function(){this.settings=$.extend({height:130,autohide:!0,hideDuration:500,timeFormat:this.settings.sticky===!0?"s":"ms",framerate:25,framepreview:!1,framepreviewTimeBound:500,sticky:!1,widgets:{left:{timelabelWidget:"fr.ina.amalia.player.plugins.controlBar.widgets.TimeLabel"},mid:{playWidget:"fr.ina.amalia.player.plugins.controlBar.widgets.PlayButton",pauseWidget:"fr.ina.amalia.player.plugins.controlBar.widgets.PauseButton"},right:{full:"fr.ina.amalia.player.plugins.controlBar.widgets.FullscreenButton",volume:"fr.ina.amalia.player.plugins.controlBar.widgets.VolumeControlBar"},settings:{}}},this.settings||{}),this.leftContainer=null,this.midContainer=null,this.rightContainer=null,this.widgets=[],this.autoHide=this.settings.sticky===!0?!1:this.settings.autohide,this.displayState=!0,this.hideDuration=this.settings.hideDuration,this.height=this.settings.height,this.autoHideStarted=!1,this.createControlBar(),this.initializeWidgets(),this.definePlayerListeners(),this.updatePlayerSize(!1),null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info(this.settings))},createControlBar:function(){var a=this.settings.sticky===!0?this.Class.classCss+" sticky":this.Class.classCss;this.container=$("<div>",{"class":a});var b=$("<div>",{"class":"row"});this.leftContainer=$("<div>",{"class":"left-container col-xs-4 col-md-4 col-lg-4"}),this.midContainer=$("<div>",{"class":"middle-container col-xs-4 col-md-4 col-lg-4"}),this.rightContainer=$("<div>",{"class":"right-container col-xs-4 col-md-4 col-lg-4"}),b.append(this.leftContainer),b.append(this.midContainer),b.append(this.rightContainer),this.container.append(b),this.container.height(this.height),this.pluginContainer.append(this.container)
},initializeWidgets:function(){var a=this.settings.widgets;if(null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info(a)),a.hasOwnProperty("left"))for(var b in a.left)this.initWidget(b,a.left[b],this.leftContainer);if(a.hasOwnProperty("mid"))for(var c in a.mid)this.initWidget(c,a.mid[c],this.midContainer);if(a.hasOwnProperty("right"))for(var d in a.right)this.initWidget(d,a.right[d],this.rightContainer);this.settings.enableProgressBar!==!1&&(this.progressBar=new fr.ina.amalia.player.plugins.controlBar.widgets.ProgressBar({debug:this.settings.debug,framepreview:this.settings.framepreview,framepreviewTimeBound:this.settings.framepreviewTimeBound},this.mediaPlayer,this.container))},initWidget:function(widgetName,widgetClassName,container){try{var settings="object"==typeof this.settings.widgets.settings[widgetName]?this.settings.widgets.settings[widgetName]:this.settings,obj=eval("new "+widgetClassName+"(settings,this.mediaPlayer,container)");this.widgets.push(obj)}catch(error){null!==this.logger&&(this.logger.warn("Error to load widget : "+widgetClassName),this.logger.warn(error.stack))}},definePlayerListeners:function(){this.mediaPlayer.mediaContainer.on(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{self:this},this.onFullscreenModeChange),this.autoHide===!0&&(this.mediaPlayer.mediaContainer.one(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlaying),this.mediaPlayer.mediaContainer.one(fr.ina.amalia.player.PlayerEventType.SEEK,{self:this},this.onSeeking)),null!==this.logger&&this.logger.trace(this.Class.fullName,"defineWidgetsListeners")},updatePlayerSize:function(a){this.settings.sticky===!0?a===!0?this.mediaPlayer.mediaContainer.find("video").first().css("height",parseInt(window.screen.height-this.height)):this.mediaPlayer.mediaContainer.find("video").first().css("height",parseInt(this.mediaPlayer.mediaContainer.parent().height()-this.height)):this.container.css("bottom",this.height+"px")},show:function(){var a=this;a.displayState===!1&&(a.container.find(".row").show(),a.container.find(".player-progress-bar").css("height","20px"),a.container.find(".player-progress-bar .ui-slider-handle").css("width","20px"),a.container.animate({bottom:a.height+"px"},250,function(){a.displayState=!0}))},hide:function(){var a=this;a.displayState===!0&&a.container.animate({bottom:"10px"},250,function(){a.container.find(".row").hide(),a.container.find(".player-progress-bar").css("height","10px"),a.container.find(".player-progress-bar .ui-slider-handle").css("width","10px"),a.displayState=!1})},onFullscreenModeChange:function(a,b){a.data.self.updatePlayerSize(b.inFullScreen)},onPlayerMouseEnter:function(a){a.data.self.displayState===!1&&a.data.self.show(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlayerMouseEnter")},onPlayerMouseLeave:function(a){a.data.self.displayState===!0&&setTimeout(function(){a.data.self.hide()},a.data.self.hideDuration),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlayerMouseLeave")},onPlaying:function(a){a.data.self.autoHideStarted===!1&&(a.data.self.autoHideStarted=!0,a.data.self.mediaPlayer.mediaContainer.on("mouseenter touchstart",{self:a.data.self},a.data.self.onPlayerMouseEnter),a.data.self.mediaPlayer.mediaContainer.on("mouseleave touchleave",{self:a.data.self},a.data.self.onPlayerMouseLeave))},onSeeking:function(a){a.data.self.autoHideStarted===!1&&(a.data.self.autoHideStarted=!0,a.data.self.hide(),a.data.self.mediaPlayer.mediaContainer.on("mouseenter touchstart",{self:a.data.self},a.data.self.onPlayerMouseEnter),a.data.self.mediaPlayer.mediaContainer.on("mouseleave touchleave",{self:a.data.self},a.data.self.onPlayerMouseLeave))}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.ContextMenuPlugin",{classCss:"plugin-context-menu dropdown-menu lg",style:"",copyrightText:"Amalia.js V1.2.3, © INA 2015",copyrightHomepage:"http://ina-foss.github.io/amalia.js"},{container:null,menuConfiguration:{position:{my:"left top",at:"right top"}},initialize:function(){this.initContextMenu()},initContextMenu:function(){this.container=$("<ul/>",{"class":this.Class.classCss,style:this.Class.style,role:"menu","aria-labelledby":"dLabel"}).menu({disabled:!1}).css({position:"fixed",left:0,top:0}).hide(),this.addItemWithLink(this.Class.copyrightText),this.addItemWithLink(fr.ina.amalia.player.PlayerMessage.PLAYER_OPENSOURCE_LINK,this.Class.copyrightHomepage,"homepage"),this.pluginContainer.append(this.container),this.container.on("mouseleave",{self:this},this.onMouseleave),this.pluginContainer.parent().on("contextmenu",{self:this},this.onContextmenu)},addItemWithLink:function(a,b,c){b=b?b:"#",c=c?c:"disabled";var d=$("<li>",{"class":c}),e=$("<a>",{text:a,target:"_blank",href:b});return d.append(e),this.container.append(d),d},onContextmenu:function(a){var b=10;a.data.self.container.show().css({left:a.clientX-b,top:a.clientY-b}),a.preventDefault()},onMouseleave:function(a){a.preventDefault(),a.data.self.container.hide()}}),$.Class("fr.ina.amalia.player.parsers.MetadataParser",{},{settings:{},logger:null,data:null,init:function(a){this.settings=$.extend({debug:!1},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug}))},parseData:function(a){var b=null;if(null!==this.logger&&this.logger.trace(this.Class.fullName,"parseData"),"undefined"!=typeof a.length){b=[];for(var c in a)a[c].hasOwnProperty("id")===!0?b.push(this.getData(a[c])):null!==this.logger&&this.logger.warn("parseData : Error to find data type.")}else a.hasOwnProperty("id")===!0?b=this.getData(a):null!==this.logger&&this.logger.warn("parseData : Error to find data type.");return b},getData:function(a){var b=null;if(b={},b.id=a.id,b.type=a.type,b.list=[],a.hasOwnProperty("localisation")===!0&&a.localisation.length>0&&a.localisation[0].hasOwnProperty("sublocalisations")===!0)for(var c=null!==a.localisation[0].sublocalisations?a.localisation[0].sublocalisations.localisation:a.localisation,d=null,e=null,f="",g="",h=0;h<c.length;h++)e=c[h],f=e.hasOwnProperty("label")===!0?e.label:"",g=e.hasOwnProperty("thumb")===!0?e.thumb:null,e.hasOwnProperty("tc")===!0&&null!==e.tc?(d={spatials:e.hasOwnProperty("spatials")===!0?e.spatials:null,data:e.hasOwnProperty("data")===!0?e.data:null,sublocalisations:e.hasOwnProperty("sublocalisations")===!0?e.sublocalisations:null,label:f,thumb:g,tclevel:e.hasOwnProperty("tclevel")===!0?e.tclevel:0,tc:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tc)},b.list.push(d)):e.hasOwnProperty("tcin")===!0&&e.hasOwnProperty("tcout")===!0&&(d={spatials:e.hasOwnProperty("spatials")===!0?e.spatials:null,data:e.hasOwnProperty("data")===!0?e.data:null,sublocalisations:e.hasOwnProperty("sublocalisations")===!0?e.sublocalisations:null,label:f,thumb:g,tclevel:e.hasOwnProperty("tclevel")===!0?e.tclevel:0,tc:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcin),tcin:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcin),tcout:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcout),duration:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcout)-fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(e.tcin)},b.list.push(d));return b}}),$.Class("fr.ina.amalia.player.LocalStorageManager",{storageNamespace:"ina.media.player"},{settings:{},logger:null,data:null,init:function(){this.initializeStorage()},initializeStorage:function(){if("undefined"!=typeof localStorage)try{localStorage.hasOwnProperty(this.Class.storageNamespace)===!1&&localStorage.setItem(this.Class.storageNamespace,JSON.stringify({})),this.data=JSON.parse(localStorage.getItem(this.Class.storageNamespace))}catch(a){this.data=null}else this.data=null},updateDataStorage:function(){try{"undefined"!=typeof localStorage&&localStorage.setItem(this.Class.storageNamespace,JSON.stringify(this.data))}catch(a){this.data=null}},hasItem:function(a){return null!==this.data&&this.data.hasOwnProperty(a)===!0},getItem:function(a){return null!==this.data&&this.data.hasOwnProperty(a)===!0?this.data[a]:null},setItem:function(a,b){try{null!==this.data&&"undefined"!=typeof a&&"undefined"!=typeof b&&(this.data[a]=b,this.updateDataStorage())}catch(c){}return null},removeItem:function(a){null!==this.data&&"undefined"!=typeof a&&(delete this.data[a],this.updateDataStorage())},clear:function(){"undefined"!=typeof localStorage&&localStorage.removeItem(this.Class.storageNamespace)}}),$.Class("fr.ina.amalia.player.mediaTypeManager",{},{mediaPlayer:null,logger:null,settings:{},init:function(a,b){if(this.mediaPlayer=b,this.namespace=this.Class.fullName,this.settings=$.extend({debug:!1,internalPlugin:!1},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),null===this.mediaPlayer)throw new Error("Can't initialize plugin name"+this.Class.fullName);this.initialize()},initialize:function(){}}),fr.ina.amalia.player.mediaTypeManager.extend("fr.ina.amalia.player.media.type.DashMpeg",{},{context:null,dashPlayer:null,initialize:function(){this.context=new Dash.di.DashContext,this.dashPlayer=new MediaPlayer(this.context)},setSrc:function(a){this.dashPlayer.startup(),this.dashPlayer.attachView(this.mediaPlayer.get(0)),this.dashPlayer.attachSource(a),null!==this.logger&&this.logger.trace(this.Class.fullName,"set dash src :"+this.url)}}),$.Class("fr.ina.amalia.player.PlayerHtml5",{mediaPlayerClassCss:"player",mediaPlayerStyleCss:"position: relative; width: inherit; height: inherit; background-color: black; "},{logger:null,settings:{},mediaContainer:null,mediaPlayer:null,pluginManager:null,localStorageManager:null,listOfMetadata:[],loaderContainer:null,errorContainer:null,isIOSDevices:!1,isRangePlayer:!1,rangePlayerTcout:null,captureId:null,captureTc:null,captureScale:1,zTcin:null,zTcout:null,tcOffset:0,mediaTypeManager:null,init:function(a,b){this.settings=$.extend({autoplay:!1,poster:"",src:"",defaultVolume:75,crossorigin:""},a||{}),void 0!==fr.ina.amalia.player.log&&void 0!==fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),this.mediaContainer=b,this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize");var a=-1!==navigator.userAgent.indexOf("iPhone"),b=-1!==navigator.userAgent.indexOf("iPod"),c=-1!==navigator.userAgent.indexOf("iPad");this.isIOSDevices=a||c||b,this.tcOffset=parseInt(this.settings.tcOffset),this.createLoaderContainer(),this.createErrorContainer(),this.createPlayer(),this.initializePlugins(),this.localStorageManager=new fr.ina.amalia.player.LocalStorageManager({}),this.setSrc(this.settings.src,this.settings.autoplay),this.setVolume(this.localStorageManager.hasItem("volume")===!1?this.settings.defaultVolume:this.localStorageManager.getItem("volume"))},initializePlugins:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initializePlugins"),this.pluginManager=new fr.ina.amalia.player.plugins.PluginManager(this.settings,this,this.mediaContainer)},setSrc:function(a,b){null!==this.logger&&this.logger.trace(this.Class.fullName,"setSrc:"+a),"mpd"===this.settings.mediaType?(this.mediaTypeManager=new fr.ina.amalia.player.media.type.DashMpeg(this.settings,this.mediaPlayer),this.mediaTypeManager.setSrc(a)):(this.mediaPlayer.find("source:first").attr({src:a}),this.load(),b===!0&&this.play())},createPlayer:function(){if(null!==this.logger&&this.logger.trace(this.Class.fullName,"createPlayer"),this.mediaPlayer=$("<video/>",{"class":this.Class.mediaPlayerClassCss,style:this.Class.mediaPlayerStyleCss}),""!==this.settings.crossorigin&&this.mediaPlayer.attr("crossorigin",this.settings.crossorigin),""!==this.settings.poster&&this.mediaPlayer.attr("poster",this.settings.poster),"mpd"!==this.settings.mediaType){var a=$("<source />");this.mediaPlayer.append(a)}this.mediaContainer.append(this.mediaPlayer),this.initEvents()},createLoaderContainer:function(){this.loaderContainer=$("<div>",{"class":"inaplayer-loader"});var a=$("<i>",{"class":"fa fa-cog fa-spin fa-5x"});this.loaderContainer.append(a),this.loaderContainer.hide(),this.mediaContainer.append(this.loaderContainer),this.showLoader()},createErrorContainer:function(){this.errorContainer=$("<div>",{"class":"inaplayer-error"}),this.errorContainer.hide(),this.mediaContainer.append(this.errorContainer)},initEvents:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"adEvents"),this.mediaPlayer.on("loadstart",{self:this},this.onLoadstart),this.mediaPlayer.on("playing",{self:this},this.onPlay),this.mediaPlayer.on("pause",{self:this},this.onPause),this.mediaPlayer.on("ended",{self:this},this.onEnded),this.mediaPlayer.one("durationchange",{self:this},this.onDurationchange),this.mediaPlayer.on("timeupdate",{self:this},this.onTimeupdate),this.mediaPlayer.find("source").on("error",{self:this},this.onSourceError),this.mediaPlayer.on("seeked",{self:this},this.onSeeked),this.mediaPlayer.on(fr.ina.amalia.player.PlayerEventType.ERROR,{self:this},this.onError),$(document).on("webkitfullscreenchange mozfullscreenchange fullscreenchange MSFullscreenChange",{self:this},this.fullScreenHandler)},load:function(){this.mediaPlayer.get(0).load()},showLoader:function(){this.loaderContainer.show()},hideLoader:function(){this.loaderContainer.hide()},play:function(){if(this.mediaPlayer.get(0).play(),"undefined"!=typeof this.settings.callbacks.onPlay)try{eval(this.settings.callbacks.onPlay+"()")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}},pause:function(){if(this.mediaPlayer.get(0).pause(),this.isRangePlayer=!1,this.rangePlayerTcout=null,"undefined"!=typeof this.settings.callbacks.onPause)try{eval(this.settings.callbacks.onPause+"()")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}},stop:function(){if(this.mediaPlayer.get(0).pause(),this.mediaPlayer.get(0).currentTime=0,"undefined"!=typeof this.settings.callback.onStop)try{eval(this.settings.callbacks.onStop+"()")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}},seek:function(a){return this.setCurrentTime(a)},mute:function(){return this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.MUTE),this.mediaPlayer.get(0).volume=0},unmute:function(){this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.UN_MUTE),this.mediaPlayer.get(0).volume=1},getMediaPlayer:function(){return this.mediaPlayer},getDuration:function(){return Math.max(this.tcOffset,this.mediaPlayer.get(0).duration+this.tcOffset)},getTcOffset:function(){return this.tcOffset},getVolume:function(){return 100*this.mediaPlayer.get(0).volume},rangePlay:function(a,b,c){c="undefined"==typeof c?!1:c,this.isRangePlayer=!0,this.rangePlayerTcout=b+this.tcOffset,this.setCurrentTime(a),c===!0&&this.play()},setVolume:function(a){return a>=0&&100>=a?(this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.VOLUME_CHANGE,{volume:a}),this.localStorageManager.setItem("volume",a),null!==this.logger&&this.logger.trace(this.Class.fullName,"setVolume"+a),this.mediaPlayer.get(0).volume=a/100):null},setCurrentTime:function(a){var b=isNaN(a)?0:a;return this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.SEEK,{currentTime:b}),this.mediaPlayer.get(0).currentTime=Math.max(0,b-this.tcOffset)},setErrorCode:function(a){if("undefined"!=typeof this.errorContainer){var b=$("<p>",{text:fr.ina.amalia.player.PlayerErrorCode.getMessage(a)});this.errorContainer.html(b),this.errorContainer.show()}},getFullscreen:function(){return fr.ina.amalia.player.helpers.HTML5Helper.isFullScreen()},getCurrentTime:function(){return this.mediaPlayer.get(0).currentTime+this.tcOffset},isPaused:function(){return this.mediaPlayer.get(0).paused},toggleFullScreen:function(){var container=this.isIOSDevices?this.mediaPlayer.get(0):this.mediaContainer.get(0),inFullScreen=fr.ina.amalia.player.helpers.HTML5Helper.toggleFullScreen(container,this.isIOSDevices);if("undefined"!=typeof this.settings.callbacks.onFullscreen)try{eval(this.settings.callbacks.onFullscreen+"(inFullScreen)")}catch(e){null!==this.logger&&this.logger.warn("Send callback failed.")}return null!==this.logger&&this.logger.trace(this.Class.fullName,"onClickFullscreenButton :"+inFullScreen),inFullScreen},fullScreenHandler:function(a){var b=$(document).context,c=b.fullscreen||b.mozFullScreen||b.webkitIsFullScreen?!0:!1;a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.FULLSCREEN_CHANGE,{inFullScreen:c}),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"fullScreenHandler :"+c)},addMetadata:function(a){if("object"==typeof a){var b=new fr.ina.amalia.player.parsers.MetadataParser(this.settings),c=b.parseData(a);if(null!==c){if("undefined"!=typeof a.length)for(var d in c)c[d].hasOwnProperty("id")===!0?("undefined"==typeof this.listOfMetadata[c[d].id]&&(this.listOfMetadata[c[d].id]=[]),this.listOfMetadata[c[d].id].push(c[d].list),null!==this.logger&&this.logger.info("AddMetadata ID:"+c[d].id)):null!==this.logger&&this.logger.warn("parseData : Error to find data type.");else"undefined"==typeof this.listOfMetadata[c.id]&&(this.listOfMetadata[c.id]=[],this.listOfMetadata[c.id].push(c.list));null!==this.logger&&this.logger.info("AddMetadata ID:"+c.id)}else null!==this.logger&&this.logger.warn("AddMetadata/Error to parse data.")}else null!==this.logger&&this.logger.warn("AddMetadata/Error: data is not object.")},setZoomTc:function(a,b,c){c="undefined"!=typeof c?c:"",(Math.ceil(this.zTcin)!==Math.ceil(a)||Math.ceil(this.zTcout)!==Math.ceil(b))&&(this.zTcin=Math.max(0,parseFloat(a)),this.zTcout=parseFloat(b),null!==this.logger&&this.logger.info("SetZoomTc: // Tcin: "+this.zTcin+" // Tcout:"+this.zTcout+" // Event Tag Name:"+c),this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.ZOOM_RANGE_CHANGE,{zTcin:parseFloat(a),zTcout:parseFloat(b),eventTag:c}))},getMetadataById:function(a){return this.listOfMetadata[a]},setMetadataById:function(a,b){if("object"==typeof b)this.listOfMetadata[a]=b;else{if("string"!=typeof b)return!1;try{var c=JSON.parse(b);this.listOfMetadata[a]=c}catch(d){return!1}}return this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.DATA_CHANGE,{id:a}),!0},getMetadataWithRange:function(a,b,c){var d=this.getMetadataById(a),e=[];if("undefined"!=typeof d){for(var f=0;f<d.length;f++)e=e.concat(this._getMetadataRangeValues(d[f],parseFloat(b),parseFloat(c)));null!==this.logger&&this.logger.trace(this.Class.fullName,"getMetadataWithRange Id:"+a+" Tcin:"+b+" Tcout:"+c+" Number of Elements:"+d.length)}else null!==this.logger&&this.logger.warn("GetMetadataWithRange:  No data id:"+a);return e},_getMetadataRangeValues:function(a,b,c){return $.grep(a,function(a){return a.tc>=b&&a.tc<=c})},getCurrentImage:function(a){var b="";try{var c=this.mediaPlayer.get(0),d=document.createElement("canvas");return a="undefined"!=typeof a?Math.min(1,parseFloat(a)):1,d.width=c.videoWidth*a,d.height=c.videoHeight*a,d.getContext("2d").drawImage(c,0,0,d.width,d.height),b=d.toDataURL("image/png"),this.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.IMAGE_CAPTURE,{currentTime:this.getCurrentTime(),captureTc:this.captureTc.toString(),captureId:this.captureId.toString(),captureImage:b.toString()}),b}catch(e){null!==this.logger&&(this.logger.warn("Error lors de la capture d'imagette"),this.logger.warn(e.stack))}return b},getTcImage:function(a,b,c){this.setCurrentTime(b),this.play(),this.captureId=a,this.captureTc=b+this.tcOffset,this.captureScale="undefined"!=typeof c?Math.min(1,parseFloat(c)):1},onLoadstart:function(event){if(null!==event.data.self.logger&&event.data.self.logger.trace(event.data.self.Class.fullName,"onLoadstart"),"undefined"!=typeof event.data.self.settings.callbacks.onReady)try{eval(event.data.self.settings.callbacks.onReady+"()")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},onPlay:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPlay"),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PLAYING,[a.data.self])},onPause:function(a){null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onPause"),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.PAUSED,[a.data.self])},onSeeked:function(a){if(a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.SEEK,{currentTime:a.data.self.getCurrentTime()}),"number"==typeof a.data.self.captureTc)try{a.data.self.getCurrentImage(a.data.self.captureScale),a.data.self.captureTc=null}catch(b){null!==a.data.self.logger&&(a.data.self.logger.warn("Error to capture Tc"),a.data.self.logger.warn(b.stack))}},onEnded:function(event){if(null!==event.data.self.logger&&event.data.self.logger.trace(event.data.self.Class.fullName,"onEnded"),event.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.ENDEN,[event.data.self]),"undefined"!=typeof event.data.self.settings.callbacks.onComplete)try{eval(event.data.self.settings.callbacks.onComplete+"()")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},onDurationchange:function(a){a.data.self.hideLoader(),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.STARTED,[a.data.self]),a.data.self.settings.autoplay===!0&&a.data.self.play()},onTimeupdate:function(event){var tcOffset=event.data.self.getTcOffset(),currentTime=event.data.self.getCurrentTime(),duration=event.data.self.getDuration(),percentage=100*(currentTime-tcOffset)/(duration-tcOffset);if(event.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:event.data.self,currentTime:currentTime,duration:duration,percentage:percentage}),event.data.self.isRangePlayer===!0&&"number"==typeof event.data.self.rangePlayerTcout&&event.data.self.rangePlayerTcout<=currentTime&&event.data.self.pause(),"undefined"!=typeof event.data.self.settings.callbacks.onTimeupdate)try{eval(event.data.self.settings.callbacks.onTimeupdate+"(currentTime)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},onSourceError:function(a){null!==a.data.self.logger&&(a.data.self.logger.warn(a.data.self.Class.fullName+" :: onSourceError"),a.data.self.logger.warn(a)),a.data.self.mediaPlayer.trigger(fr.ina.amalia.player.PlayerEventType.ERROR,{self:a.data.self,errorCode:fr.ina.amalia.player.PlayerErrorCode.MEDIA_FILE_NOT_FOUND})},onError:function(event,data){null!==event.data.self.logger&&event.data.self.logger.trace(event.data.self.Class.fullName,"onError");var errorCode="undefined"==typeof data.errorCode?"":data.errorCode;if(event.data.self.setErrorCode(errorCode),"undefined"!=typeof event.data.self.settings.callbacks.onError)try{eval(event.data.self.settings.callbacks.onError+"(errorCode)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}},addMenuItemWithLink:function(a,b,c){if("object"==typeof this.pluginManager&&"function"==typeof this.pluginManager.getContextMenuPlugin){var d=this.pluginManager.getContextMenuPlugin();if("object"==typeof d&&"function"==typeof d.addItemWithLink)return d.addItemWithLink(a,b,c)}return!1}}),function(a){a.fn.mediaPlayer=function(b){return this.each(function(){var c=a(this),d="fr.ina.amalia.player";if(c.data(d))return null;b=a.extend({plugins:{},src:null,framerate:25,autoplay:!0,controlBarClassName:"fr.ina.amalia.player.plugins.CustomControlBarPlugin",controlBar:{},tcOffset:0,mediaType:"mp4",debug:!1},b||{});var e=new fr.ina.amalia.player.MediaFactory(this,b);c.data(d,e),c.addClass("inaplayerhtml5"),c.attr("style","width: 100%; height:100%;"),c.parent().css("position","relative")})}}(jQuery);