/*!Amalia.js V1.2.3, © INA 2015 */
/**
 * Copyright (c) 2015 Institut National de l'Audiovisuel, INA
 * This file is part of amalia.js

 * amalia.js is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

 * Redistributions of source code, javascript and css minified versions
 * must retain the above copyright notice, this list of conditions and the following disclaimer.

 * Neither the name of the copyright holder nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.

 * You should have received a copy of the GNU General Public License
 * along with amalia.js. If not, see <http://www.gnu.org/licenses/>

 *
 * amalia.js is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

$.Class("fr.ina.amalia.player.plugins.overlay.SpatialsDataParser",{},{data:null,spatials:null,settings:{},logger:null,init:function(a,b){this.data=b,this.spatials=[],this.settings=$.extend({debug:!1},a||{}),"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),null!==this.data&&this.initialize()},initialize:function(){null!==this.logger&&this.logger.trace(this.Class.fullName,"initialize"),this.parserMetadata()},parserMetadata:function(){for(var a=null,b=0;b<this.data.length;b++)a=this.data[b],a.hasOwnProperty("spatials")&&null!==a.spatials&&this.parserSpatials(a);null!==this.logger&&(this.logger.trace(this.Class.fullName,"parserMetadata"),this.logger.info(this.data))},parserSpatials:function(a){var b=a.spatials,c=null,d=null,e=null;if(b.hasOwnProperty("spatial")&&"object"==typeof b.spatial){e=b.spatial;for(var f=0;f<e.length;f++)null===c?c=e[f]:(d=e[f],this.addSpatial(c,d,a),c=e[f])}},addSpatial:function(a,b,c){"object"==typeof a&&"object"==typeof b&&a.hasOwnProperty("tc")&&b.hasOwnProperty("tc")?this.spatials.push({start:a,end:b,type:this.getType(a),data:c.data,label:c.label,thumb:c.thumb,tcin:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(a.tc),tcout:fr.ina.amalia.player.helpers.UtilitiesHelper.convertHourToSeconde(b.tc)}):null!==this.logger&&(this.logger.warn(this.Class.fullName+": Error to add spatial"),this.logger.warn([a,b]))},getType:function(a){return a.hasOwnProperty("point")&&null!==a.point?"point":a.hasOwnProperty("ellipse")&&null!==a.ellipse?"ellipse":"rect"},getData:function(){return $.extend(!0,[],this.spatials)}}),$.Class("fr.ina.amalia.player.plugins.overlay.DrawBase",{classCss:"draw-base",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.overlay.DrawBase.eventTypes.CLICK"}},{settings:{},logger:null,container:null,mediaPlayer:null,element:null,labelElement:null,data:null,init:function(a,b,c){if(this.mediaPlayer=b,this.data=c,this.settings=$.extend({debug:!1,container:null,canvas:null,demo:!1,style:{fill:"#00CCFF",strokeWidth:1,stroke:"#000",fillOpacity:0,strokeDasharray:"- "}},a||{}),this.container=this.settings.container,"undefined"!=typeof fr.ina.amalia.player.log&&"undefined"!=typeof fr.ina.amalia.player.log.LogHandler&&(this.logger=new fr.ina.amalia.player.log.LogHandler({enabled:this.settings.debug})),"object"==typeof this.settings.canvas&&null!==this.data&&this.initialize(),null!==this.mediaPlayer){var d=this.mediaPlayer.getMediaPlayer();d.on(fr.ina.amalia.player.PlayerEventType.PLAYING,{self:this},this.onPlay),d.on(fr.ina.amalia.player.PlayerEventType.PAUSED,{self:this},this.onPause)}},initialize:function(){null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info(this.data))},getStyle:function(){return{fill:this.settings.style.fill,stroke:this.settings.style.stroke,"stroke-width":this.settings.style.strokeWidth,"fill-opacity":this.settings.style.fillOpacity,"stroke-dasharray":this.settings.style.strokeDasharray}},onClick:function(a){null!==a.data.self.container&&a.data.self.container.trigger(fr.ina.amalia.player.plugins.overlay.DrawBase.eventTypes.CLICK,{tcin:a.data.tcin,tcout:a.data.tcout,data:a.data.data})},onPlay:function(a){null!==a.data.self.element&&a.data.self.element.resume()},onPause:function(a){null!==a.data.self.element&&a.data.self.element.pause()},onEndOfAnimation:function(){this.data("demo")!==!0&&this.remove()}}),fr.ina.amalia.player.plugins.overlay.DrawBase.extend("fr.ina.amalia.player.plugins.overlay.DrawRect",{classCss:"spatial-base"},{initialize:function(){if(this.data.hasOwnProperty("tcin")&&this.data.hasOwnProperty("tcout")&&this.data.hasOwnProperty("start")&&this.data.hasOwnProperty("end")){var a=this.getStyle(),b=this.getRectData(this.data.start),c=this.getRectData(this.data.end),d=parseFloat(this.data.tcout-this.data.tcin),e=this.data.hasOwnProperty("label")?this.data.label:"";if(null!==b&&null!==c){if(this.element=this.settings.canvas.rect(b.x,b.y,b.w,b.h),this.element.attr(a),this.element.transform("r"+Math.round(b.o/Math.PI*180)),this.element.attr({cursor:"pointer"}),this.element.data("demo",this.settings.demo),this.settings.labels===!0&&""!==e&&(this.labelElement=this.settings.canvas.text(b.x+b.w/2,b.y+b.h/2,e).attr({font:"12px Arial",opacity:1,fill:"#000"})),null!==this.mediaPlayer&&!this.mediaPlayer.isPaused()){var f={x:c.x,y:c.y,width:c.w,height:c.h,transform:"r"+Math.round(c.o/Math.PI*180)};if(this.element.stop().animate(f,1e3*d,"",this.onEndOfAnimation),null!==this.labelElement){var g={x:c.x+c.w/2,y:c.y+c.y/2};this.labelElement.stop().animate(g,1e3*d,"",this.onEndOfAnimation)}}return $(this.element.node).on("click",{self:this,data:this.data,tcin:this.data.tcin,tcout:this.data.tcout},this.onClick),null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info({data:this.data,start:b,end:c})),!0}}null!==this.logger&&(this.logger.error("Error :"+this.Class.fullName+":initialize"),this.logger.error(this.data))},getRectData:function(a){var b={x:0,y:0,width:0,height:0,r:0,o:0};try{var c=this.settings.canvas.width,d=this.settings.canvas.height;if(a.hasOwnProperty("rect"))return b.x=a.rect.x*c,b.y=a.rect.y*d,b.w=a.rect.w*c,b.h=a.rect.h*d,b.o=a.rect.o,b}catch(e){null!==this.logger&&(this.logger.error("Error to parse data GetRectData "),this.logger.error(a))}return null}}),fr.ina.amalia.player.plugins.overlay.DrawBase.extend("fr.ina.amalia.player.plugins.overlay.DrawEllipse",{classCss:"spatial-ellipse"},{initialize:function(){if(this.data.hasOwnProperty("tcin")&&this.data.hasOwnProperty("tcout")&&this.data.hasOwnProperty("start")&&this.data.hasOwnProperty("end")){var a=this.getStyle(),b=this.getEllipseData(this.data.start),c=this.getEllipseData(this.data.end),d=parseFloat(this.data.tcout-this.data.tcin),e=this.data.hasOwnProperty("label")?this.data.label:"";if(null!==b&&null!==c){if(this.element=this.settings.canvas.ellipse(b.cx,b.cy,b.rx,b.ry),this.element.attr(a),this.element.transform("r"+Math.round(b.o/Math.PI*180)),this.element.attr({cursor:"pointer"}),this.settings.labels===!0&&""!==e&&(this.labelElement=this.settings.canvas.text(b.cx,b.cy,e).attr({font:"12px Arial",opacity:1,fill:"#000"})),null!==this.mediaPlayer&&!this.mediaPlayer.isPaused()){var f={cx:c.cx,cy:c.cy,rx:c.rx,ry:c.ry,transform:"r"+Math.round(c.o/Math.PI*180)};if(this.element.stop().animate(f,1e3*d,"",this.onEndOfAnimation),null!==this.labelElement){var g={x:c.cx,y:c.cy};this.labelElement.stop().animate(g,1e3*d,"",this.onEndOfAnimation)}}return $(this.element.node).on("click",{self:this,data:this.data,tcin:this.data.tcin,tcout:this.data.tcout},this.onClick),null!==this.logger&&(this.logger.trace(this.Class.fullName,"initialize"),this.logger.info({data:this.data,start:b,end:c})),!0}}null!==this.logger&&(this.logger.error("Error :"+this.Class.fullName+":initialize"),this.logger.error(this.data))},getEllipseData:function(a){var b={x:0,y:0,rx:0,ry:0,o:0};try{var c=this.settings.canvas.width,d=this.settings.canvas.height;if(a.hasOwnProperty("ellipse"))return b.cx=a.ellipse.xc*c,b.cy=a.ellipse.yc*d,b.rx=a.ellipse.hw*c,b.ry=a.ellipse.hh*d,b.o=a.ellipse.o,b}catch(e){null!==this.logger&&(this.logger.error("Error to parse data getEllipseData"),this.logger.error(a))}return null}}),fr.ina.amalia.player.plugins.PluginBase.extend("fr.ina.amalia.player.plugins.OverlayPlugin",{classCss:"inaplayerhtml5-plugin plugin-overlay",eventTypes:{CLICK:"fr.ina.amalia.player.plugins.OverlayPlugin.eventTypes.CLICK"}},{spatialsDataParser:null,spatialsData:null,container:null,canvas:null,initialize:function(){this.settings=$.extend({offsetTime:1,callbacks:{}},this.settings||{}),this.container=$("<div>",{"class":this.Class.classCss}),this.pluginContainer.append(this.container),this.canvas=null,this.spatialsData=null,this.definePlayerListeners()},initializeOnLoadStart:function(){this.updateMetadata(this.settings.metadataId,0,this.mediaPlayer.getDuration()),this.pluginContainer.append(this.container),this.createCanvas(),this.createContextMenuOption()},definePlayerListeners:function(){var a=this.mediaPlayer.getMediaPlayer();a.one(fr.ina.amalia.player.PlayerEventType.PLUGIN_READY,{self:this},this.onFirstTimechange),a.on(fr.ina.amalia.player.PlayerEventType.ENDEN,{self:this},this.onEnd),a.on(fr.ina.amalia.player.PlayerEventType.TIME_CHANGE,{self:this},this.onTimeupdate),a.on(fr.ina.amalia.player.PlayerEventType.SEEK,{self:this},this.onSeek),$(window).on("resize",{self:this},this.onWindowResize),null!==this.logger&&this.logger.trace(this.Class.fullName,"definePlayerListeners")},createContextMenuOption:function(){var a=this.mediaPlayer.addMenuItemWithLink(fr.ina.amalia.player.PlayerMessage.PLUGIN_OVERLAY_CONTEXT_MENU_ENABLED_DISABLED_PLUGIN,"#","presentation");"object"==typeof a&&$(a).on("click",{self:this},function(a){a.preventDefault(),a.data.self.changeDisplayState()})},changeDisplayState:function(){this.container.is(":visible")?this.container.hide():this.container.show()},updateMetadata:function(a,b,c){var d=this.mediaPlayer.getMetadataWithRange(a,b,c);this.spatialsDataParser=new fr.ina.amalia.player.plugins.overlay.SpatialsDataParser(this.settings,d),this.spatialsData=this.spatialsDataParser.getData(),null!==this.logger&&(this.logger.trace(this.Class.fullName,"updateMetadata metadataId: "+a+" tcin :"+b+" tcout:"+c),this.logger.info(this.spatialsData))},updatePos:function(a){if("undefined"!=typeof this.spatialsData&&null!==this.spatialsData&&"object"==typeof this.spatialsData&&this.spatialsData.length>0){a=parseFloat(a);var b=this.getDisplayItems(a);b.length>0&&this.createObject(b)}},getDisplayItems:function(a){for(var b=null,c=this.spatialsData,d=[],e=0;e<this.spatialsData.length;e++)b=this.spatialsData[e],"object"==typeof b&&b.hasOwnProperty("tcin")&&a>=parseFloat(b.tcin)&&a<=parseFloat(b.tcin)+this.settings.offsetTime&&(d.push(b),c.splice(e,1));return this.spatialsData=c,d},createCanvas:function(){var a=this.getVideoSize(),b=a.w,c=a.h;this.canvas=new Raphael(this.container.get(0),b,c),this.canvas.canvas.className.baseVal="overlay-canvas",this.updateCanvasPosition(),this.container.on(fr.ina.amalia.player.plugins.overlay.DrawBase.eventTypes.CLICK,{self:this},this.onClickAtObject),null!==this.logger&&this.logger.trace(this.Class.fullName,"CreateCanvas width:"+b+" height: "+c)},getVideoSize:function(){var a=this.mediaPlayer.getMediaPlayer(),b=a.get(0).videoHeight,c=a.get(0).videoWidth,d=a.width()/c,e=a.height()/b,f=Math.min(d,e);return{w:f*c,h:f*b}},updateCanvasPosition:function(){var a=this.getVideoSize();this.container.find(".overlay-canvas").css({left:(this.container.width()-a.w)/2,top:(this.container.height()-a.h)/2})},createObject:function(a){if(null!==a&&"undefined"!=typeof a){var b=$.extend({canvas:this.canvas,container:this.container,debug:this.settings.debug},this.settings.parameters||{}),c=null,d=null;if("object"==typeof a&&a.length>0)for(var e=0;e<a.length;++e)c=a[e],c.hasOwnProperty("type")&&("rect"===c.type?d=new fr.ina.amalia.player.plugins.overlay.DrawRect(b,this.mediaPlayer,a[e]):"ellipse"===c.type?d=new fr.ina.amalia.player.plugins.overlay.DrawEllipse(b,this.mediaPlayer,a[e]):null!==this.logger&&this.logger.warn(this.Class.fullName+": L'objet ne peut pas être interpreté."))}else this.logger.error("Error to create object"),this.logger.error(a)},clearCanvas:function(){this.canvas.clear(),this.spatialsData=this.spatialsDataParser.getData(),null!==this.logger&&this.logger.trace(this.Class.fullName,"clearCanvas : "+this.spatialsData.length)},onWindowResize:function(a){var b=a.data.self.getVideoSize(),c=b.w,d=b.h;null!==this.canvas&&(a.data.self.clearCanvas(),a.data.self.canvas.setSize(c,d),a.data.self.updateCanvasPosition()),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"onWindowResize W: "+c+" H:"+d)},onFirstTimechange:function(a){a.data.self.initializeOnLoadStart(),null!==a.data.self.logger&&a.data.self.logger.trace(a.data.self.Class.fullName,"timechange")},onEnd:function(a){a.data.self.clearCanvas()},onTimeupdate:function(a,b){a.data.self.updatePos(parseFloat(b.currentTime))},onSeek:function(a){a.data.self.clearCanvas()},onClickAtObject:function(event,data){if("undefined"!=typeof event.data.self.settings.parameters.callbacks.click)try{eval(event.data.self.settings.parameters.callbacks.click+"(data)")}catch(e){null!==event.data.self.logger&&event.data.self.logger.warn("Send callback failed.")}null!==event.data.self.logger&&(event.data.self.logger.info(event.data.self.Class.fullName,"onClickAtObject"),event.data.self.logger.warn(event.data),event.data.self.logger.warn(data))}});